#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "direction.h"
#include "position.h"
#include "request.h"
#include "routine.h"

int routine_revert(){
	const int speed_rot = 45; // 回転速度 [deg/s]
	const int dist_dir  = 70 - 15 ; // 60; // 中央オブジェの壁との正対補正距離 [cm]
	
	//int pos_x, pos_y, pos_dir, angle_ref, dir_flag;
	double pos_x, pos_y, pos_dir;
	run_state_t state;
	int speed, dist;
	int angle_ref, dir_flag;
	char area;
	
	printf("\n復帰ルーチン開始\n");
	
	position_get_coord(&pos_x, &pos_y, &pos_dir);
	area = position_get_area();
	printf("現在の座標 : area %c (x = %d, y = %d, dir = %d)\n", area, (int)pos_x, (int)pos_y, (int)pos_dir);
	
	// 例外エリアの処理 : 何もせずに巡回動作へ移行
	switch(area){
	case 'A':
		angle_ref = 360 - pos_dir;
		dir_flag = 0;
		break;
	case 'B':
		angle_ref =  90 - pos_dir;
		dir_flag = 0;
		break;
	case 'C':
		angle_ref = 180 - pos_dir;
		dir_flag = 0;
		break;
	case 'D':
		angle_ref = 270 - pos_dir;
		dir_flag = 0;
		break;
	case 'a':
		//angle_ref = 270 - pos_dir; //前進時
		angle_ref = 90 - pos_dir; // 後退時
		dir_flag = 1;
		break;
	case 'b':
		//angle_ref = 360 - pos_dir;
		angle_ref = 180 - pos_dir;
		dir_flag = 1;
		break;
	case 'c':
		//angle_ref =  90 - pos_dir;
		angle_ref =  270 - pos_dir;
		dir_flag = 1;
		break;
	case 'd':
		//angle_ref = 180 - pos_dir;
		angle_ref = 360 - pos_dir;
		dir_flag = 1;
		break;
	default:
		angle_ref = 0;
		dir_flag = 0;
		break;
	}
	
	if(angle_ref >  180) angle_ref -= 360;
	if(angle_ref < -180) angle_ref += 360;
	
	printf("巡回経路復帰中： 回転[%d]\n", angle_ref);
	request_set_runmode(ROT, speed_rot, angle_ref);
	while(1){
		request_get_runmode(&state, &speed, &dist);
                if( state == STP ) break;
		usleep(1000);
	}
	position_rotate((double)angle_ref);

	int str_back = -60+15 ; // -60 中央オブジェにに近い場合の後退距離 [cm]
	int speed_back = 40 ; //後退速度 [cm/s]
	
	if(dir_flag == 1){

		printf("巡回経路復帰中： 後退[%d]\n", str_back);
		request_set_runmode(STR, speed_back, str_back);
		while(1){
			request_get_runmode(&state, &speed, &dist);
                	if( state == STP ) break;
			usleep(1000);
		}
		position_straight((double)str_back);

		printf("巡回経路復帰中: 正対補正[%d]\n", dist_dir);
		if(direction_correct(dist_dir) == 0){
			printf("正対補正に成功\n");
		}else{
			printf("正対補正に失敗\n");
		}
		position_correct((double)dist_dir);
		
		//printf("巡回経路復帰中 : 回転[%d]\n", 90);
		//request_set_runmode(ROT, speed_rot, 90); //前身時
		printf("巡回経路復帰中 : 回転[%d]\n", -90);
		request_set_runmode(ROT, speed_rot, -90); //後退時
		while(1){
			request_get_runmode(&state, &speed, &dist);
                	if( state == STP ) break;
			usleep(1000);
		}
		position_rotate(90.0);
	}
	
	printf("復帰ルーチン終了\n");
	usleep(1000);
	
	return 0;
}
