#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <wiringPi.h>
#include "arduino.h"
#include "circle.h"
#include "io.h"
//#include "position.h"
#include "request.h"
#include "routine.h"
#include "uss.h"
#include "number.h"
#include "camera.h"
#include "flag.h"
#include "stop_detect.h"
#include "key_watch.h"
#include "io.h"
#include "audio.h"

int main(){
	int i;
	//float volt;
	double volt;
	enum {SEARCH, CHASE, ESCAPE, AVOID} state = SEARCH;
	// コース設定 //enum {LEFT, RIGHT, LABO} course = LEFT;
	//course = LEFT;
	//course = RIGHT;
	//course = LABO;

	//usleep(100*1000);
	//printf("\n");
	printf("Pilot program start !!!\n");

	clear_state_flag();
	clear_run_flag();

	if(io_open() < 0){
		printf("failed to open GPIO device\n");
		return -1;
	}
	if(arduino_open() < 0){
		printf("failed to open Arduino\n");
		return -1;
	}
	if(uss_open_l() < 0){
		printf("failed to open USS device L\n");
		return -1;
	}
	if(uss_open_r() < 0){
		printf("failed to open USS device R\n");
		return -1;
	}

	//オーディオスレッド生成
	//audio_create();
	
	FILE *fp2;
	request_get_batt( &volt );
	//最初のデータは正しくないのでバッテリー値取り直す
	usleep(500*1000);
	request_get_batt( &volt );
	usleep(500*1000);
	request_get_batt( &volt );
	printf(" バッテリ電圧 : %3f\n", volt);
	if(volt < 6.0){
		printf("バッテリ切れによりプログラムを中止\n");
		//audio_setnum(6);
		system("aplay audio/battery_off.wav");
		for( i = 0; i < 10; i++){
			digitalWrite(pin_led_r, 1);
			usleep(100*1000);
			digitalWrite(pin_led_r, 0);
			usleep(100*1000);
		}
		fp2 = fopen("batt.off","w");
		fprintf(fp2, "battery off !!!\n");
		fclose(fp2);
		return -1;
	}
	if(volt < 7.2){
		//printf("バッテリ交換時期です\n");
		system("aplay audio/battery_low.wav");
		audio_setnum(7);
		for( i = 0; i < 3; i++){
			digitalWrite(pin_led_r, 1);
			usleep(300*1000);
			digitalWrite(pin_led_r, 0);
			usleep(300*1000);
		}
	}

	//camera_set(0);
	//camera_set(1);

	if(camera_set(0) < 0){
		printf("failed to open camera 0 \n");
		return -1;
	}
	if(camera_set(1) < 0){
		printf("failed to open camera 1 \n");
		return -1;
	}

	FILE *fp;
	//ファイルオープン
	fp = fopen("start_file.txt","w");
	fprintf(fp, "started !!!\n");
	fclose(fp);

	//LED点灯
	digitalWrite(pin_led_g, 1);
	//audio_setnum(8); //準備できました
	system("aplay audio/ready.wav");

	//キー入力を待つ
	char key_in; 
	printf("press enter to start\n");
	key_in  = getchar();

	//LED消灯
	digitalWrite(pin_led_g, 0);

	// 入力キーが q または 2 のとき機動を中止
	if( key_in == 'q' || key_in == '2') {
		fp2 = fopen("batt.off","w");
		fprintf(fp2, "battery off !!!\n");
		fclose(fp2);
		return 0;
	}

	//初期状態の設定
	state = SEARCH;

	//赤丸検出の設定
	circle_camera_set();
	circle_camera_set2();

	//赤丸認識スレッドの生成
	circle_create();
	circle_create2();

	//停止動作スレッド生成
	stop_detect_create();

	//超音波スレッド生成
	uss_create();

	//キー監視スレッド生成
	key_watch_create();

	//オーディオスレッド生成
	audio_create();

	while(1){

		printf("Flag state  circle=%d   avoid=%d   sccpae=%d\n",circle_flag,avoid_flag,escape_flag);

		//if( circle_flag == 0 && avoid_flag == 0 ) state = SEARCH;
		//if( circle_flag == 0 && avoid_flag == 1 ) state = AVOID;
		//if( circle_flag == 1) state = CHASE;
		// //if( escape_flag == 1) state = ESCAPE;

		if( circle_flag == 0 ) state = SEARCH;
		if( circle_flag == 1) state = CHASE;
		if( avoid_flag == 1 ) state = AVOID;

		switch(state){
			case SEARCH:
				audio_setnum(1);
				routine_search();
				//audio_setnum(2);
				break;
			case CHASE:
				//audio_setnum(3);
				routine_chase();
				break;
			case AVOID:
				//audio_setnum(5);
				routine_avoid();
				break;
			case ESCAPE:
				routine_escape();
				break;
		}
		if( quit_flag == 1) break;
		usleep(10*1000);

	}
	

	// pilot 終了処理
	request_set_runmode(STP, 0, 0);
	
	circle_cancel();
	circle_cancel2();
	stop_detect_cancel();
	key_watch_cancel();
	audio_cancel();

	camera_release();
	arduino_close();
	
	return 0;
}
