#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "flag.h"

void request_set_runmode(run_state_t run_state, int speed, int dist){

	command_data_t command_data;
	
	//command_data.val[0] = ((run_state == STR) ? 2 : (run_state == ROT) ? 3 : 1);
	command_data.val[0] = ((run_state == STR) ? 2 : (run_state == ROT) ? 3 : (run_state == VEL) ? 4 : 1);
	command_data.val[1] = speed;
	command_data.val[2] = dist;

	if(run_state == STP); clear_run_flag();
	if(run_state == STR){
		if( dist > 0) forward_flag = 1;
		if( dist < 0) backward_flag = 1;
	}
	if(run_state == ROT); rotate_flag = 1;;
	
	arduino_send(command_data);
}

int request_get_runmode(run_state_t *run_state, int *speed, int *dist){
	command_data_t command_data;
	
	command_data.val[0] = 10;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		//*run_state = ((command_data.val[0] == 2) ? STR : (command_data.val[0] == 3) ? ROT : STP);
		*run_state = ((command_data.val[0] == 2) ? STR : (command_data.val[0] == 3) ? ROT : (command_data.val[0] == 4) ? VEL : STP);
		*speed = command_data.val[1];
		*dist  = command_data.val[2];
		return 0;
	}else{
		return -1;
	}
}

int request_get_dist(int *dist_l, int *dist_r){
	command_data_t command_data;
	
	command_data.val[0] = 11;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		*dist_l = command_data.val[0];
		*dist_r = command_data.val[1];
		return 0;
	}else{
		return -1;
	}
}

int request_get_batt(double *volt){
	command_data_t command_data;
	
	command_data.val[0] = 12;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		*volt = command_data.val[0] / 100.0;
		return 0;
	}else{
		return -1;
	}
}
