#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "circle.h"
#include "io.h"
//#include "position.h"
#include "request.h"
#include "routine.h"
#include "flag.h"
#include "uss.h"
#include "audio.h"

typedef enum{FWD, BACK, ROT_C, END, DUMY} chase_state_t;

//static void stop_fwd();

static int get_uss();

int routine_chase(){

	const int speed_str = 40; //50 50 65 40 直進速度 [cm/s]
	const int speed_rot = 40; //30 40 45 回転速度 [deg/s]
	const int param     =  2; //3; // 5 風船と認識する赤色エリアの割合 [%]
	const int param2    = 22; //15// 方向変更を行う風船角度の閾値 [deg]
	const int far_dist = 200; //[cm]
	const int close_dist = 40; //[cm]
	int speed_left;
	int speed_right;
	int uss = 50;
	
	int count = 0;
	int ratio, cir_x, cir_y, cir_dir, angle_ref;
	//int radius, cir_x2, cir_y2, cir_dir2;
	run_state_t run_state;
	int speed, dist;
	
	chase_state_t state_curr = DUMY;
	chase_state_t state_prev = DUMY;
	
	printf("\n追跡ルーチン開始\n");


	while(1){

		//printf("追跡中[%d] ：前進\n", count);
		//sleep(1);

		if( quit_flag == 1) break;
		
		count++;
		
		circle_get_cg(&cir_x, &cir_y, &ratio);
		//circle_get_cir(&cir_x2, &cir_y2, &radius);

		//if(stop_flag == 1) return -1; //停止を検知したので出る
		
		// 角度 = 座標 * 視野角 / 画像サイズ
		//cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
		cir_dir = (cir_x - IMG_CIR_X / 2) * 30 / IMG_CIR_X;
		//cir_dir2 = (cir_x2 - IMG_CIR_X / 2) * 30 / IMG_CIR_X;
		
		if(ratio > param){
			printf("赤色を認識 (比率 = %d, 角度 = %d)\n", ratio, cir_dir);
			//printf("赤色を認識 (半径 = %d, 角度 = %d)\n", radius, cir_dir2);
			//赤丸を発見した
			circle_flag  = 1 ;
			//audio_setnum(2);

			if(abs(cir_dir) > param2){
				state_curr = ROT_C;
			}else{
				state_curr = FWD;
			}
		}else{
			printf("赤色を見失った\n");
			audio_setnum(4);
			circle_flag  = 0 ;
			state_curr = END;
		}
		
		// 前進から他のモードに移行する場合は停止処理を行う
		//if(state_prev == FWD && state_curr != FWD) stop_fwd();
		
		switch(state_curr){

		  case END:
			printf("追跡ルーチン終了\n");
			//circle_cancel();
			request_set_runmode(STP, 0, 0);
			//clear_run_flag();
			audio_setnum(4);
			usleep(100*1000);
			return 0; //風船を見失ったので追跡ルーチンを出る
			//break;

		  case ROT_C:
			angle_ref = -cir_dir;
			
			printf("追跡中：方向変更[%d]\n", angle_ref);
			
			request_set_runmode(ROT, speed_rot, angle_ref);
			
			while(1){
				request_get_runmode(&run_state, &speed, &dist);
				//if(stop_flag == 1) return -1; //停止を検知したので出る
                                if( run_state == STP ) break;
				usleep(1000);
			}

			//clear_run_flag();
			break;

		  case DUMY:
			break;

		  case FWD:
			audio_setnum(3);
			//speed_left = speed_str +  cir_dir * 1.6;
			//speed_right = speed_str -  cir_dir * 1.6;

			speed = speed_str;
			uss = get_uss();
			//printf( " uss = %d\n", uss);

			// 1m のときratioは10[%]
			if( ratio < 12){
				speed = speed_str + (12 - ratio) * 3.5;
			}
			///指定距離まで近づいたら止まる
			if( uss < close_dist || ratio > 50 ) {
				speed = 0;
			}
/*
			if( uss <= far_dist ){
				speed = ( uss - close_dist) * 0.5;
			}
			if ( uss > far_dist) {
				speed = ( far_dist - close_dist) * 0.5;
			}
			if ( uss < 0) {
				speed = 0;
			}
*/

			//speed = 0 ; // for test

			//20181207 コメント
			//speed_left = speed +  cir_dir * 1.6;
			//speed_right = speed -  cir_dir * 1.6;
			request_set_runmode(VEL, speed_left, speed_right);

			//20181207 追加
			// この日作成した Arduino Ver3.2.0 は以下が対応している
			request_set_runmode(VEL, speed, speed);


			// 他のモードから直進に変更された場合のみ新たに直進指令を出す
			//if(state_prev != FWD){
			//		printf("追跡中：前進指令 \n");
			//	request_set_runmode(STR, speed_str, 255);
			//}
			break;
		default:
			break;
		}
		
		state_prev = state_curr;
		usleep(20 * 1000);
	}
	
	return 0;
}

/*
void stop_fwd(){

	int dist_l, dist_r;
	request_get_dist(&dist_l, &dist_r);
	double dist_fwd = (double)( dist_l + dist_r) /2;

	request_set_runmode(STP, 0, 0);
	printf("前進終了 (前進距離 = %d)\n", (int)dist_fwd);

}
*/

int get_uss(){

	int uss = 80;
	int uss_l, uss_r, us_l, us_r;
	int uss_min = 15;
	int uss_max = 200;

	uss_get_val( &us_l ,&us_r);
	if( uss_min < us_l  && us_l < uss_max){
		uss_l = us_l ;
	} else {
		uss_l = -1;
	}
	if( uss_min < us_r  && us_r < uss_max){
		uss_r = us_r ;
	} else {
		uss_r = -1;
	}
	if( uss_l > 0 && uss_r > 0 ){
		if( uss_l > uss_r ){
			uss = uss_l ;
		} else {
			uss = uss_r ;
		}
	}	
	if( uss_l > 0 && uss_r < 0) uss = uss_l;
	if( uss_l < 0 && uss_r > 0) uss = uss_r;

	return uss;

}

