#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include "direction.h"
#include "io.h"
#include "position.h"
#include "request.h"
#include "routine.h"
#include "flag.h"

int speed, dist;

int routine_escape(){

	run_state_t run_state;
	int dist_ref, angle_ref;
	//int ret, ratio, cir_x, cir_y, cir_dir, ratio2, cir_x2, cir_y2, cir_dir2;

	const int speed_str = 40; // 直進速度 [cm/s]
	const int speed_rot = 30; // 回転速度 [deg/s]
	const int rot_min = 90;
	const int rot_max = 180;

	int rot_dir ;
	//int count = 0;

	printf("\n 脱出ルーチン開始\n");

	stop_flag = 0; // stop_flag をクリアする
		
	//指定距離後退する
	dist_ref = -50;
	printf("脱出モード : 直進[%d]\n", dist_ref);
	request_set_runmode(STR, speed_str, dist_ref);
	while(1){
               	request_get_runmode(&run_state, &speed, &dist);
               	if( run_state == STP ) {
			clear_run_flag();
			break;
		}
		//後退中に止まってしまった場合は停止して回転動作へ移行
		if( stop_flag == 1){
			request_set_runmode(STP, 0 , 0);
			break; 
		}	
		usleep(1000);
	}
	
	srand((unsigned)time(NULL));
	//適当な角度回転する（90-180）
	if(rand()%2 == 1){
		rot_dir = 1;
	}else{
		rot_dir = -1;
	}
	angle_ref = rot_min + rand()%(rot_max - rot_min + 1) * rot_dir ;//乱数で生成
	printf("動作モード : 回転[%d]\n", angle_ref);
	request_set_runmode(ROT, speed_rot , angle_ref);

	while(1){
		request_get_runmode(&run_state, &speed, &dist);
               	if( run_state == STP ) {
			clear_run_flag();
			break;
		}
		//回転中に止まってしまった場合は停止して一旦脱出モードを抜ける
		if( stop_flag == 1){
			request_set_runmode(STP, 0 , 0);
			break; 
		}	
		usleep(1000);
	}

	return 0;
}


