#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include "circle.h"
#include "direction.h"
#include "io.h"
//#include "position.h"
#include "request.h"
#include "routine.h"
#include "flag.h"
#include "audio.h"
#include "uss.h"

static run_state_t run_state;
int speed, dist;
//int ans[NUM_LEN];
static void  rotate_to_circle();
static void  rotate_to_circle_back();
static int ret, dist_ref, angle_ref;
static int ratio, cir_x, cir_y, cir_dir, ratio2, cir_x2, cir_y2, cir_dir2;

int routine_search(){
	//const int speed_str = 60; // 90 120 70 60 直進速度 [cm/s]
	//const int speed_rot = 45; // 回転速度 [deg/s]
	//const int dist_dir  = 70; // 74 // 正対補正距離 [cm]
	//const int dist_dir  = 70+15; // 正対補正距離 [cm]、中心に近いところを走行

	const int speed_str = 20; // 30; // 直進速度 [cm/s]
	const int speed_rot = 30; // 回転速度 [deg/s]
	//const int dist_dir  = 35; // 74 // 正対補正距離 [cm]
	const int dist_min = 50; //30
	const int dist_max = 125; //100
	const int rot_min = 90;
	const int rot_max = 180;
	enum {FR, RT} search_state = RT ;

	int us_l, us_r;
	//int uss_min = 25;
	int uss_min = 35;
	
	const int ratio_ref =  3 ; // 5 風船と認識する赤色エリアの割合 [%]

	//double pos_x, pos_y, pos_dir;
	//char area;
	//int sw_f, sw_l, sw_r;
	//int dist_l, dist_r;
	int rot_dir ;
	int count = 0;
	
	srand((unsigned)time(NULL));
	//search_state = RT; // 初期動作は回転

	while(1){

		if( quit_flag == 1) break;

		printf("\n 探索ルーチン[%d]開始\n", count);
		count ++;
		
		clear_run_flag();
		ret = 0;
		
		switch(search_state){
		  case FR:
			dist_ref = dist_min + rand()%(dist_max - dist_min + 1) ;//乱数で生成
			printf("動作モード : 直進[%d]\n", dist_ref);
			request_set_runmode(STR, speed_str, dist_ref);
			
			while(1){
				if( quit_flag == 1) break;
				circle_get_cg(&cir_x, &cir_y, &ratio);
				circle_get_cg2(&cir_x2, &cir_y2, &ratio2);
				
				// 角度 = 座標 * 視野角 / 画像サイズ
				//cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
				//cir_dir2 = (cir_x2 - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
				cir_dir = (cir_x - IMG_CIR_X / 2) * 30 / IMG_CIR_X;
				cir_dir2 = (cir_x2 - IMG_CIR_X / 2) * 30 / IMG_CIR_X;

                        	uss_get_val( &us_l ,&us_r);
                        	if( us_l < uss_min || us_r < uss_min ){
                                	printf("回避フラッグ=1  us_l = %d    us_r = %d\n", us_l, us_r);
                               		avoid_flag = 1;
					request_set_runmode(STP, 0, 0);
					usleep(1000);
					return 0;
                        	} else {
                                	avoid_flag = 0;
                        	}
				
                                request_get_runmode(&run_state, &speed, &dist);
				if( run_state == STP ){
					request_set_runmode(STP, 0, 0);
					search_state = RT;
					break;
				}
				if(ratio > ratio_ref){
					rotate_to_circle();
					return 0;
				}
				if(ratio2 > ratio_ref){
					rotate_to_circle_back();
					return 0;
				}
				
				usleep(1000);
			}

		  case RT:
			//angle_ref = 85 ; // 87; // 90
			//angle_ref = rand() ; // 方向を含め乱数で発生
			if(rand()%2 == 1){
				rot_dir = 1;
			}else{
				rot_dir = -1;
			}
			angle_ref = (rot_min + rand()%(rot_max - rot_min + 1) ) * rot_dir ;//乱数で生成
			printf("動作モード : 回転[%d]\n", angle_ref);
			request_set_runmode(ROT, speed_rot , angle_ref);

			while(1){
				if( quit_flag == 1) break;
				circle_get_cg(&cir_x, &cir_y, &ratio);
				circle_get_cg2(&cir_x2, &cir_y2, &ratio2);
				
				// 角度 = 座標 * 視野角 / 画像サイズ
				cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
				cir_dir2 = (cir_x2 - IMG_CIR_X / 2) * 60 / IMG_CIR_X;

				request_get_runmode(&run_state, &speed, &dist);
				if( run_state == STP ){
					request_set_runmode(STP, 0, 0);
					search_state = FR;
					break;
				}
				if(ratio > ratio_ref){
					rotate_to_circle();
					return 0;
				}
				if(ratio2 > ratio_ref){
					rotate_to_circle_back();
					return 0;
				}

				usleep(1000);
			}

                       	uss_get_val( &us_l ,&us_r);
                        if( us_l < uss_min || us_r < uss_min ){
                               	printf("回避フラッグ=1  us_l = %d    us_r = %d\n", us_l, us_r);
                        	avoid_flag = 1;
				request_set_runmode(STP, 0, 0);
				return 0;
                        } else {
                               	avoid_flag = 0;
                        }

			
		  default:
			break;

		}

		usleep(1000);
	}

	return 0;
}


void  rotate_to_circle(){

	int speed_rot = 30;

	printf("前方に赤色を認識 (比率 = %d, 角度 = %d)\n", ratio, cir_dir);
	angle_ref = -cir_dir;
	request_set_runmode(ROT, speed_rot , angle_ref);
	while(1){
		request_get_runmode(&run_state, &speed, &dist);
		if( run_state == STP ) break;
		usleep(1000);
	}
	//printf("ルーチン終了\n");
	request_set_runmode(STP, 0, 0);

	//風船発見フラグを立てる
	circle_flag = 1;
}


void  rotate_to_circle_back(){

	int speed_rot_rapid = 120; //90
	printf("後方に赤色を認識 (比率 = %d, 角度 = %d)\n", ratio2, cir_dir2);
				
	if(cir_dir2 >= 0){
		angle_ref = 180 - cir_dir2;
	}else{
		angle_ref = -180 - cir_dir2;
	}
	
	printf("後方回転角= %d\n", angle_ref);
	audio_setnum(2);
	request_set_runmode(ROT, speed_rot_rapid , angle_ref);
	while(1){
		request_get_runmode(&run_state, &speed, &dist);
		if( run_state == STP ) break;
		usleep(1000);
	}
			
	printf("後方回転ルーチン終了\n");
	request_set_runmode(STP, 0, 0);

	//風船発見フラグを立てる
	circle_flag = 1;
	
	
}
