#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/time.h>
#include "request.h"
#include "stop_detect.h"
#include "flag.h"

static void *thread_code(void*);
static pthread_t task_id;

void *thread_code(void *t){
	// 実行周期[ms]
	const int cycle = 500; //250
	int cnt=0;

	while(1){
		stop_detect();
		//printf("circle thread count = %d\n", cnt);
		usleep(cycle * 1000);
		cnt++ ;
	}
	
	return 0;
}


int stop_detect_create(){
	int policy;
	struct sched_param param;
	
	// スレッドの生成
	if(pthread_create(&task_id, NULL, thread_code, NULL) != 0){
		printf("failed to create stop_detect thread\n");
		return -1;
	}
	
	// スレッドパラメータの確認
	pthread_getschedparam(task_id, &policy, &param);
	printf("circle thread created (plicy = %s, priority = %d)\n",
		((policy == SCHED_FIFO) ? "SCHED_FIFO" : (policy == SCHED_RR) ? "SCHED_RR" : (policy == SCHED_OTHER) ? "SCHED_OTHER" : "???"),
		param.sched_priority);

	return 0;
}

void stop_detect_cancel(){
	pthread_cancel(task_id);
	printf("stop_detect thread canceled\n");
}

int stop_detect(){

	static int dist_l, dist_r;
	static int dist_l_prev = 0, dist_r_prev = 0;
	static int count = 0;
	static int count_max = 5;


	//request_get_dist(&dist_l, &dist_r);

	if( dist_l == dist_l_prev && dist_r == dist_r_prev ){
		count++;
		if(count >= count_max) stop_flag = 1;
	}else{
		count = 0;
		stop_flag = 1;
	}

	dist_l_prev = dist_l;
	dist_r_prev = dist_r;
	
	return 0;

}
